function A = numbering_matrix_sr2_types(type, m, n);

%This funktion will provide the numbered matrix for r = sqrt(2) and m >= 4

A = zeros(m,n);
count = 1;
mVec = 1:m;
nVec = 1:n;
re = mVec(2:2:m);
ro = mVec(1:2:m);
ce = nVec(2:2:n);
co = nVec(1:2:n);
    
if type == 1 
        [A, count] = type1(A,m,n,re,ce,2,2,count);               
        [A, count] = type2(A,m,n,ro,ce,1,2,count);       
        [A, count] = type1(A,m,n,ro,co,1,1,count);        
        [A, count] = type2(A,m,n,re,co,2,1,count);
elseif type == 2
        [A, count] = type8(A,m,n,re,ce,4,4,count);               
        [A, count] = type3(A,m,n,re,co,4,1,count);       
        [A, count] = type4(A,m,n,ro,co,1,3,count);        
        [A, count] = type5(A,m,n,ro,ce,3,2,count);
elseif type == 3
        [A, count] = type8(A,m,n,re,co,4,3,count);               
        [A, count] = type3(A,m,n,re,ce,4,2,count);       
        [A, count] = type4(A,m,n,ro,ce,1,4,count);        
        [A, count] = type5(A,m,n,ro,co,3,1,count);
elseif type == 4
        [A, count] = type8(A,m,n,re,ce,4,4,count);               
        [A, count] = type8(A,m,n,re,co,4,3,count);       
        [A, count] = type4(A,m,n,ro,co,1,3,count);        
        [A, count] = type5(A,m,n,ro,ce,3,2,count);
elseif type == 5
        [A, count] = type8(A,m,n,ro,ce,3,4,count);               
        [A, count] = type3(A,m,n,ro,co,3,1,count);       
        [A, count] = type4(A,m,n,re,co,2,3,count);        
        [A, count] = type3(A,m,n,re,ce,4,2,count);
elseif type == 6
        [A, count] = type8(A,m,n,ro,co,3,3,count);               
        [A, count] = type3(A,m,n,ro,ce,3,2,count);       
        [A, count] = type4(A,m,n,re,ce,2,4,count);        
        [A, count] = type3(A,m,n,re,co,4,1,count);
elseif type == 7
        [A, count] = type8(A,m,n,ro,co,3,3,count);               
        [A, count] = type4(A,m,n,re,co,2,3,count);       
        [A, count] = type3(A,m,n,re,ce,4,2,count);        
        [A, count] = type8(A,m,n,ro,ce,3,4,count);
elseif type == 8
        [A, count] = type8(A,m,n,re,ce,4,4,count);               
        [A, count] = type8(A,m,n,ro,ce,3,4,count);       
        [A, count] = type3(A,m,n,ro,co,3,1,count);        
        [A, count] = type6(A,m,n,re,co,2,3,count);
elseif type == 9
        [A, count] = type8(A,m,n,ro,co,3,3,count);               
        [A, count] = type3(A,m,n,ro,ce,3,2,count);       
        [A, count] = type4(A,m,n,re,ce,2,4,count);        
        [A, count] = type8(A,m,n,re,co,4,3,count);
elseif type == 10
    for i = 1:4,
    [A,count] = type7(A,m,n,re,ce,2,2,count);
    A = rot90(A);
    end;
end

end


function [A,count] = type1(A,m,n,r,c,sr,sc,count)
if mod(length(r),2) == 0
        A(r,sc) = count:count+length(r)-1;
        count = count+length(r)-1+1;
        help = true;
        for i = fliplr(r),
            if help
                A(i,c(2:end)) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = false;
            else
                A(i,fliplr(c(2:end))) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = true;
            end
        end
else
    A(r,sc) = count:count+length(r)-1;
    count = count+length(r)-1+1;
    help = true;
    for i = c(2:end),
            if help
                A(fliplr(r(2:end)),i) = count:count+length(r(2:end))-1;
                count = count+length(r(2:end))-1+1;
                help = false;
            else
                A(r(2:end),i) = count:count+length(r(2:end))-1;
                count = count+length(r(2:end))-1+1;
                help = true;
            end
    end
    A(sr,fliplr(c(2:end))) = count:count+length(c(2:end))-1;
    count = count+length(c(2:end))-1+1;
end
end

function [A,count] = type2(A,m,n,r,c,sr,sc,count)
if mod(length(r),2) == 0
    A(sr,c) = count:count+length(c)-1;
        count = count+length(c)-1+1;
        help = true;
        for i = r(2:end),
            if help
                A(i,fliplr(c(2:end))) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = false;
            else
                A(i,c(2:end)) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = true;
            end
        end
        A(fliplr(r(2:end)),sc) = count:count+length(r(2:end))-1;
        count = count+length(r(2:end))-1+1;
else
     A(sr,c) = count:count+length(c)-1;
        count = count+length(c)-1+1;
        help = true;
        for i = fliplr(c),
            if help
                A(r(2:end),i) = count:count+length(r(2:end))-1;
                count = count+length(r(2:end))-1+1;
                help = false;
            else
                A(fliplr(r(2:end)),i) = count:count+length(r(2:end))-1;
                count = count+length(r(2:end))-1+1;
                help = true;
            end
        end
end
end

function [A,count] = type3(A,m,n,r,c,sr,sc,count)

min = count;
minn = count;
[A,count] = type2(A,m,n,r,c,sr-2,sc,count);

max = count-1;

for i = max:-1:max-((max-minn+1)/2)+1,
    [r,c] = find(A == i);
    [ro,co] = find(A == min);
    if i ~= min
        A(r,c) = min;
        A(ro,co) = i;
        min = min+1;
    end
end
end

function [A,count] = type4(A,m,n,r,c,sr,sc,count)

min = count;
minn = count;
[A,count] = type1(A,m,n,r,c,sr,sc-2,count);

max = count-1;

for i = max:-1:max-((max-minn+1)/2)+1,
    [r,c] = find(A == i);
    [ro,co] = find(A == min);
    if i ~= min
        A(r,c) = min;
        A(ro,co) = i;
        min = min+1;
    end
end
end

function [A,count] = type5(A,m,n,r,c,sr,sc,count)
if mod(length(r),2) == 0
    A(sr,sc) = count;
    count = count+1;
    A(sr-2,c) = count:count+length(c)-1;
        count = count+length(c)-1+1;
        help = true;
        for i = r(2:end),
            if help
                A(i,fliplr(c(2:end))) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = false;
            else
                A(i,c(2:end)) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = true;
            end
        end
        A(fliplr(r(3:end)),sc) = count:count+length(r(3:end))-1;
        count = count+length(r(3:end))-1+1;
else
    A(sr,sc) = count;
    count = count+1;
    A(sr-2,c) = count:count+length(c)-1;
        count = count+length(c)-1+1;
        help = true;
        for i = fliplr(c(2:end)),
            if help
                A(r(2:end),i) = count:count+length(r(2:end))-1;
                count = count+length(r(2:end))-1+1;
                help = false;
            else
                A(fliplr(r(2:end)),i) = count:count+length(r(2:end))-1;
                count = count+length(r(2:end))-1+1;
                help = true;
            end
        end
        A(fliplr(r(3:end)),sc) = count:count+length(r(3:end))-1;
        count = count+length(r(3:end))-1+1;
end
end

function [A,count] = type6(A,m,n,r,c,sr,sc,count)
if mod(length(r),2) == 0
    A(sr,sc) = count;
    count = count+1;
    A(r,sc-2) = count:count+length(r)-1;
    count = count+length(r)-1+1;
    help = true;
        for i = fliplr(r(2:end)),
            if help
                A(i,(c(2:end))) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = false;
            else
                A(i,fliplr(c(2:end))) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = true;
            end
        end
        A(r(1),fliplr(c(3:end))) = count:count+length(c(2:end))-1;
        count = count+length(c(2:end))-1+1;
else
    A(sr,sc) = count;
    count = count+1;
    A(r,sc-2) = count:count+length(r)-1;
    count = count+length(r)-1+1;
    help = true;
        for i = c(2:end),
            if help
                A(fliplr(r(2:end)),i) = count:count+length(r(2:end))-1;
                count = count+length(r(2:end))-1+1;
                help = false;
            else
                A(r(2:end),i) = count:count+length(r(2:end))-1;
                count = count+length(r(2:end))-1+1;
                help = true;
            end
        end
        A(r(1),fliplr(c(3:end))) = count:count+length(c(3:end))-1;
        count = count+length(c(3:end))-1+1;
end
end

function [A,count] = type7(A,m,n,r,c,sr,sc,count)
if mod(length(r),2) == 1
    A(sr,c) = count:count+length(c)-1;
    count = count+length(c)-1+1;
    A(r(2:end),c(end)) = count:count+length(r(2:end))-1;
    count = count+length(r(2:end))-1+1;
    help = true;
        for i = fliplr(r(2:end)),
            if help
                A(i,(fliplr(c(1:end-1)))) = count:count+length(c(1:end-1))-1;
                count = count+length(c(1:end-1))-1+1;
                help = false;
            else
                A(i,c(1:end-1)) = count:count+length(c(1:end-1))-1;
                count = count+length(c(1:end-1))-1+1;
                help = true;
            end
        end

elseif mod(length(c),2) == 0
    A(sr,c) = count:count+length(c)-1;
    count = count+length(c)-1+1;
    A(r(2:end),c(end)) = count:count+length(r(2:end))-1;
    count = count+length(r(2:end))-1+1;
    A(r(end),(fliplr(c(1:end-1)))) = count:count+length(c(1:end-1))-1;
    count = count+length(c(1:end-1))-1+1;
    help = true;
        for i = c(1:end-1),
            if help
                A(fliplr(r(2:end-1)),i) = count:count+length(r(2:end-1))-1;
                count = count+length(r(2:end-1))-1+1;
                help = false;
            else
                A(r(2:end-1),i) = count:count+length(r(2:end-1))-1;
                count = count+length(r(2:end-1))-1+1;
                help = true;
            end
        end
end
end

function [A,count] = type8(A,m,n,r,c,sr,sc,count)

    A(sr,c(2:2:end-1)) = count:4:count+4*length(c(2:2:end-1))-4;
    A(sr,c(3:2:end)) = count+3:4:count+4*length(c(3:2:end))-1;
    A(sr-2,c(2:2:end-1)) = count+1:4:count+4*length(c(2:2:end-1))-3;
    A(sr-2,c(3:2:end)) = count+2:4:count+4*length(c(3:2:end))-2;
    
    count = count+4*length(c(3:2:end))-1+1;
    
    help = true;
        for i = r(3:end),
            if help
                A(i,(fliplr(c(2:end)))) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = false;
            else
                A(i,c(2:end)) = count:count+length(c(2:end))-1;
                count = count+length(c(2:end))-1+1;
                help = true;
            end
        end
    A(fliplr(r), c(1)) = count:count+length(r)-1;
    count = count+length(r)-1+1;
end
